module Data.Array (
    module Data.Ix,
    Array,
    array,
    listArray,
    accumArray,
    (!),
    bounds,
    indices,
    elems,
    assocs,
    (//),
    accum,
    ixmap,
  ) where

import Data.Ix

    -- Array instances:
    --
    --   Ix a => Functor (Array a)
    --   (Ix a, Eq b)  => Eq   (Array a b)
    --   (Ix a, Ord b) => Ord  (Array a b)
    --   (Ix a, Show a, Show b) => Show (Array a b)
    --   (Ix a, Read a, Read b) => Read (Array a b)
    --

    array,          -- :: (Ix a) => (a,a) -> [(a,b)] -> Array a b
    listArray,      -- :: (Ix a) => (a,a) -> [b] -> Array a b
    accumArray,     -- :: (Ix a) => (b -> c -> b) -> b -> (a,a) -> [(a,c)] -> Array a b
    (!),            -- :: (Ix a) => Array a b -> a -> b
    bounds,         -- :: (Ix a) => Array a b -> (a,a)
    indices,        -- :: (Ix a) => Array a b -> [a]
    elems,          -- :: (Ix a) => Array a b -> [b]
    assocs,         -- :: (Ix a) => Array a b -> [(a,b)]
    (//),           -- :: (Ix a) => Array a b -> [(a,b)] -> Array a b
    accum,          -- :: (Ix a) => (b -> c -> b) -> Array a b -> [(a,c)] -> Array a b
    ixmap,          -- :: (Ix a, Ix b) => (a,a) -> (a -> b) -> Array b c -> Array a b
